library IEEE;
use IEEE.std_logic_1164.all;


entity counter_10 is   --  
        port (  
                main_clk, res, enab : in bit; --   , . , .
        counter_out : out integer range 0 to 1023 --  
        );
end counter_10;
entity counter10 is --  10-    
        port (
                c_in,enab_c,res_c:in bit;
                c_out:out integer range 0 to 1023
        );
end counter10;

architecture count of counter10 is --   
begin
        process (c_in, res_c)
        variable cnt:integer range 0 to 1023;
        begin
                if (res_c='0') then 
                        cnt:=0;
                elsif (c_in'event and c_in='1') then 
                        if (enab_c='1') then cnt:=cnt+1;
                        end if;
                end if;
                c_out<=cnt;
        end process;
end count;

architecture a of counter_10 is --   
        component counter10  --   
        port (
                c_in,enab_c,res_c:in bit;
                c_out:out integer range 0 to 1023
                );
        end component;

begin
        mc: counter10 --    
        port map (c_in=>main_clk,enab_c=>enab,res_c=>res,c_out=>counter_out);
end a; 